(if (fboundp 'original-broken-encode-time)
    nil
  (if (equal (encode-time 0 0 0 1 1 2001 0)
	     (encode-time 0 0 0 1 1 2001 43200))
      (fset 'original-broken-encode-time (symbol-function 'encode-time))))

(defun revised-encode-time (&rest args)
  "Convert SECOND, MINUTE, HOUR, DAY, MONTH, YEAR and ZONE to internal time.
This is the reverse operation of `decode-time', which see.
ZONE defaults to the current time zone rule.  This can
be a string (as from `set-time-zone-rule'), or it can be a list
\(as from `current-time-zone') or an integer (as from `decode-time')
applied without consideration for daylight savings time.

You can pass more than 7 arguments; then the first six arguments
are used as SECOND through YEAR, and the *last* argument is used as ZONE.
The intervening arguments are ignored.
This feature lets (apply 'encode-time (decode-time ...)) work.

Out-of-range values for SEC, MINUTE, HOUR, DAY, or MONTH are allowed;
for example, a DAY of 0 means the day preceding the given month.
Year numbers less than 100 are treated just like other year numbers.
If you want them to stand for years in this century, you must do that yourself.
"
  (let* ((len (length args))
	 (tz (if (> len 6) (nth (1- len) args)))
	 (time (apply 'original-broken-encode-time args))
	 ms ls)
    (if (numberp tz)
	(progn
	  (setq ms (car time)
		ls (- (car (cdr time)) tz))
	  (cond ((< ls 0)
		 (list (1- ms) (+ ls 65536)))
		((> ls 65535)
		 (list (1+ ms) (- ls 65536)))
		(t
		 (list ms ls))))
      time)))

(if (fboundp 'original-broken-encode-time)
    (fset 'encode-time 'revised-encode-time))
